<?php
/**
 * The template for displaying the footer
 *
 * Contains the opening of the #site-footer div and all content after.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package WordPress
 * @subpackage car
 * @since car
 */

?>

<section class="footer-top no-padding">
    <div class="container">
        <div class="footer-top-bg row">
            <div class="col-md-4 footer-box one">
                <i class="fa fa-map-marker">&nbsp;</i>
                <div class="footer-box-content">
                    <h3>Head Office</h3>
                    <p>8230 FRANKFORD AVE, SUITE 8, Philadelphia, PA 19136</p>
                </div>
            </div>
            <!--/ Box 1 end -->

            <div class="col-md-4 footer-box two">
                <i class="fa fa-phone">&nbsp;</i>
                <div class="footer-box-content">
                    <h3>Call Center</h3>
                    <p>TEL: 215-333-0333</p>
                    <p>FAX: 215-333-9333</p>
                </div>
            </div>
            <!--/ Box 2 end -->

            <div class="col-md-4 footer-box three">
                <i class="fa fa-envelope-o">&nbsp;</i>
                <div class="footer-box-content">
                    <h3>Email</h3>
                    <p>info@expeditedautotag.com</p>
                    <p><a class="footer_email" href="mailto:info@expeditedautotagandinsuranceinc.com">info@expeditedautotagandinsuranceinc.com</a></p>
                </div>
            </div>
            <!--/ Box 3 end -->

        </div>
        <!--/ Content row end -->
    </div>
    <!--/ Container end -->
</section>
<!--/ Footer top end -->

<!-- Footer start -->
<footer id="footer" class="footer">
    <div class="container">
        <div class="row">
            <div class="col-md-4 col-sm-12 footer-widget footer-about">
                <div class="footer-logo">
                    <img src="<?php bloginfo('template_directory');?>/images/carlogo.png" alt="">
                </div>

                <p>Expedited Auto Tag & Insurance Inc. uses some of the Insurance industry’s most advanced technologies and platforms to connect to some of the nation’s bigger carriers. What this means, for our clients, is that every client, regardless of his/her risk factors, will have the opportunities to make a choice from rock-bottomed quotations provided by multiple-carriers; taking into consideration one goal. </p>
            </div><!-- About us end -->

            <div class="col-md-4 col-sm-12 footer-widget">
                <h3 class="widget-title">Important Links</h3>

                    <?php 
                            wp_nav_menu( array('menu' => 'primary' ,
                            'menu_class' => 'list-arrow',
                            'menu_id' => '' ,
                            'container' => ''));
                            ?>
                    <!-- <ul class="list-arrow">
                    <li><a href="#">Get insurance</a></li>
                    <li><a href="#">Manage Insurance</a></li>
                    <li><a href="#">Learn insurance</a></li>
                    <li><a href="#">Products &amp; services</a></li>
                    <li><a href="#">Why SaifWay</a></li>
                    <li><a href="#">How claims work</a></li>
                    <li><a href="#">Why use an adviser?</a></li>
                    <li><a href="#">The risk</a></li>
                    <li><a href="#">Underinsurance</a></li>
                    <li><a href="#">Manage Insurance</a></li>
                    <li><a href="#">Learn insurance</a></li>
                    <li><a href="#">Insurance Quotes</a></li>
                    <li><a href="#">Product Disclosure</a></li>
                </ul> -->
            </div>

            <div class="col-md-4 col-sm-12 footer-widget">
                <h3 class="widget-title">Subscribe with us</h3>
                <div class="newsletter-introtext">
                    Subscribe with our newsletters and receive news about our discounts.
                </div>
                <form action="#" method="post" id="newsletter-form" class="newsletter-form">
                    <div class="form-group">
                        <input type="email" name="email" id="newsletter-form-email" class="form-control form-control-lg"
                            placeholder="Your Email Here" autocomplete="off">
                        <button class="btn btn-primary">Subscribe</button>
                    </div>
                </form>

                <div class="footer-social">
                    <h3 class="widget-title">Stay Connected</h3>
                    <ul>
                        <li><a href="#"><i class="fa fa-rss"></i></a></li>
                        <li><a href="https://www.facebook.com/Expedited-Auto-Tag-Insurance-Inc-100751665016289/"><i class="fa fa-facebook"></i></a></li>
                        <li><a href="#"><i class="fa fa-twitter"></i></a></li>
                        <li><a href="#"><i class="fa fa-linkedin"></i></a></li>
                        <li><a href="#"><i class="fa fa-dribbble"></i></a></li>
                    </ul>
                </div><!-- Footer social end -->
            </div>
        </div>
        <!--/ Content row end -->

        <div class="row copyright">
            <div class="col-xs-12 col-sm-12">
                <div class="copyright-info">
                    <span>Copyright © 2020 Expedited Auto Tag. Developed by <a href="https://codeyourbusiness.com/" target=_blank>Codeyourbusiness.com</a>.</span>
                </div>
            </div>
        </div><!-- Copyright end -->

        <div id="back-to-top" data-spy="affix" data-offset-top="10" class="back-to-top affix">
            <button class="btn btn-primary" title="Back to Top">
                <i class="fa fa-angle-double-up"></i>
            </button>
        </div>

    </div>
    <!--/ Container end -->
</footer><!-- Footer end -->



<!-- initialize jQuery Library -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/jquery.js"></script>
<!-- Bootstrap jQuery -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/bootstrap.min.js"></script>
<!-- Owl Carousel -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/owl.carousel.min.js"></script>
<!-- Counter -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/jquery.counterup.min.js"></script>
<!-- Waypoints -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/waypoints.min.js"></script>
<!-- Color box -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/jquery.colorbox.js"></script>
<!-- Isotope -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/isotope.js"></script>
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/ini.isotope.js"></script>
<!-- Template custom -->
<script type="text/javascript" src="<?php bloginfo('template_directory');?>/js/custom.js"></script>




<?php wp_footer(); ?>

</div><!-- Body inner end -->
</body>

</html>