<?php
/**
 * Header file for the Twenty Twenty WordPress default theme.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package WordPress
 * @subpackage technology
 * @since technology 1.0
 */

?>
<!DOCTYPE html>

<html class="no-js" <?php language_attributes(); ?>>

<head>

    <meta charset="<?php bloginfo( 'charset' ); ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="profile" href="https://gmpg.org/xfn/11">

    <!-- Bootstrap -->
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/bootstrap.min.css">
    <!-- Template styles-->
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/style.css">
    <!-- Responsive styles-->
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/responsive.css">
    <!-- FontAwesome -->
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/font-awesome.min.css">
    <!-- Animation -->
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/animate.css">
    <!-- Owl Carousel -->
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/owl.carousel.css">
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/owl.theme.css">
    <!-- Colorbox -->
    <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/colorbox.css">


    <?php wp_head(); ?>

</head>

<body <?php body_class(); ?>>



    <div class="body-inner">

        <div id="top-bar" class="top-bar">
            <div class="container">
                <div class="row">

                    <div class="col-md-6 col-sm-6 col-xs-12 top-social">
                        <ul class="unstyled">
                            <li>
                                <a title="Facebook" href="https://www.facebook.com/Expedited-Auto-Tag-Insurance-Inc-100751665016289/">
                                    <span class="social-icon"><i class="fa fa-facebook"></i></span>
                                </a>
                                <a title="Twitter" href="#">
                                    <span class="social-icon"><i class="fa fa-twitter"></i></span>
                                </a>
                                </a>
                                <a title="Linkdin" href="#">
                                    <span class="social-icon"><i class="fa fa-linkedin"></i></span>
                                </a>
                                <a title="instagram" href="#">
                                    <span class="social-icon"><i class="fa fa-instagram"></i></span>
                                </a>
                            </li>
                        </ul>
                    </div>
                    <!--/ Top social end -->

                    <div class="col-md-6 col-sm-6 col-xs-12 top-menu ">
                        <ul class="unstyled">
                            <li><a href="#" class="popmake-40 pum-trigger">Get a Quote</a></li>
                            <li><a href="https://appointment.expeditedautotagandinsuranceinc.com/" target="_blank">Book Appointment</a></li>
                        </ul>
                    </div>
                    <!--/ Top menu end -->

                </div>
                <!--/ Content row end -->
            </div>
            <!--/ Container end -->
        </div>
        <!--/ Topbar end -->

        <!-- Header start -->
        <header id="header" class="header">
            <div class="container">
                <div class="row">
                    <div class="logo col-xs-12 col-sm-3">
                        <a href="<?php echo home_url(''); ?>">
                            <?php 
                            $custom_logo_id = get_theme_mod( 'custom_logo' );
                            $image = wp_get_attachment_image_src( $custom_logo_id , 'full' );
                            ?>
                            <!-- <img src="<<?php echo $image[0]; ?>" alt="Logo" class="logo_img"> -->
                            <img src="<?php bloginfo('template_directory');?>/images/carlogo.png" alt="">
                        </a>
                    </div><!-- logo end -->

                    <div class="col-xs-12 col-sm-7 header-right">
                        <ul class="top-info">
                            <li>
                                <div class="info-box"><span class="info-icon"><i
                                            class="fa fa-map-marker">&nbsp;</i></span>
                                    <div class="info-box-content">
                                        <p class="info-box-title">8230 Frankford Ave, Suite 8</p>
                                        <p class="info-box-subtitle">Philadelphia, PA 19136</p>
                                    </div>
                                </div>
                            </li>
                            <li>
                                <div class="info-box"><span class="info-icon"><i class="fa fa-phone">&nbsp;</i></span>
                                    <div class="info-box-content">
                                        <p class="info-box-title">215-333-0333</p>
                                        <p class="info-box-subtitle">info@expeditedautotag.com</p>
                                    </div>
                                </div>
                            </li>
<!--                             <li>
                                <div class="info-box"><span class="info-icon"><i class="fa fa-compass">&nbsp;</i></span>
                                    <div class="info-box-content">
                                        <p class="info-box-title">09:00Am - 08:00Pm</p>
                                        <p class="info-box-subtitle">Monday to Friday</p>
                                    </div>
                                </div>
                            </li> -->
                        </ul>
                    </div><!-- header right end -->
                </div><!-- Row end -->
            </div><!-- Container end -->
        </header>
        <!--/ Header end -->

        <nav class="site-navigation navigation">
            <div class="container">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="site-nav-inner pull-left">
                            <button type="button" class="navbar-toggle" data-toggle="collapse"
                                data-target=".navbar-collapse">
                                <span class="sr-only">Toggle navigation</span>
                                <span class="icon-bar"></span>
                                <span class="icon-bar"></span>
                                <span class="icon-bar"></span>
                            </button>



                            <div class="collapse navbar-collapse navbar-responsive-collapse">

                                
                                <!-- <ul class="nav navbar-nav">
                                    <li class="active"><a href="index.html">Home </a></li>
                                    <li class=""><a href="index.html">About Us</a></li>
                                    <li class=""><a href="index.html">Insutance</a></li>
                                    <li class=""><a href="index.html">FAQ</a></li>
                                    <li class=""><a href="index.html">Contact </a></li>
                                </ul> -->
                                <!--/ Nav ul end -->
								<ul class="nav navbar-nav">
                                    <li class=""><a href="<?php echo home_url(''); ?>">Home </a></li>
                                    <li class=""><a href="<?php echo home_url('about-us'); ?>">About Us</a></li>
									<li class=""><a href="https://shop.expeditedautotagandinsuranceinc.com/">Shop</a></li>
									<li class="dropdown">
										<a href="#" class="dropdown-toggle" data-toggle="dropdown">Services <i
												class="fa fa-angle-down"></i></a>
										<ul class="dropdown-menu" role="menu">
											<li><a href="<?php echo home_url('insurance-products-services'); ?>">Insurance Products & Services</a></li>
											<li><a href="<?php echo home_url('notary-public-services'); ?>">Notary Public Services</a></li>
											<li><a href="<?php echo home_url('penndot-dmv-related-services'); ?>">PennDot/DMV Related Services</a></li>
										</ul>
									</li>
                                    <li class=""><a href="<?php echo home_url('faq'); ?>">FAQ</a></li>
                                    <li class=""><a href="https://www.dmv.pa.gov/_layouts/pa.penndot.formsandpubs/formsandpubs.aspx" target="_blank">PennDot/DMV Forms</a></li>
                                    <li class=""><a href="<?php echo home_url('contact'); ?>">Contact </a></li>
                                </ul>
								
                            </div>
                            <!--/ Collapse end -->

                        </div><!-- Site Navbar inner end -->

                        <!-- <div class="find-agent pull-right">
                    <a href="#">Find Agent</a>
                </div> -->

                    </div>
                    <!--/ Col end -->
                </div>
                <!--/ Row end -->
            </div>
            <!--/ Container end -->
        </nav>
        <!--/ Navigation end -->